Module SQL資料庫系統管理
    Friend Sub SQL_系統權限預設表_單一讀取()
        ConnOpen() : SQL1 = "SELECT 職稱, " & 系統權限 & " FROM 系統權限預設表 WHERE 職稱 LIKE N'" & PA40 & "' ORDER BY 職稱" : CmdSet_For_DGV()
    End Sub
    Friend Sub SQL_系統使用者管理_使用者清單()
        If BL = False Then
            ConnOpen()
            If PA = "" Then
                If 在職 = True Then
                    If 工人 = False Then : SQL2 = " WHERE (CC63 = 0) AND (部門 NOT LIKE N'9%') " : Else : SQL2 = " WHERE (CC63 = 0) AND (部門 LIKE N'9%') " : End If
                Else
                    If 工人 = False Then : SQL2 = " WHERE (CC63 = 1) AND (部門 NOT LIKE N'9%') " : Else : SQL2 = " WHERE (CC63 = 1) AND (部門 LIKE N'9%') " : End If
                End If
                SQL1 = "SELECT  " & 登入權限1 & " FROM 使用者權限管理表 " & SQL2 & " ORDER BY 部門, 職稱, 課別, 組別, 姓名"
            Else
                If 登入人級別 = "00" Then : SQL2 = "" : Else : If 在職 = True Then : SQL2 = " AND (CC63 = 0)" : Else : SQL2 = " AND (CC63 = 1)" : End If : End If
                SQL1 = "SELECT    " & 登入權限1 & " FROM 使用者權限管理表 
                        WHERE   ((姓名 LIKE N'%" & PA & "%') OR (帳號 LIKE N'%" & PA & "%') OR (密碼 LIKE N'%" & PA & "%') OR 
                                 (職稱 LIKE N'%" & PA & "%')) " & SQL2 & "
                        ORDER BY  部門, 職稱, 課別, 組別, 姓名"
            End If
            CmdSet_For_DGV()
        Else
            ConnOpen()
            If PA = "" Then
                If 在職 = True Then
                    If 工人 = False Then : SQL2 = " AND (CC63 = 0) AND (部門 NOT LIKE N'9%') " : Else : SQL2 = " AND (CC63 = 0) AND (部門 LIKE N'9%') " : End If
                Else
                    If 工人 = False Then : SQL2 = " AND (CC63 = 1) AND (部門 NOT LIKE N'9%') " : Else : SQL2 = " AND (CC63 = 1) AND (部門 LIKE N'9%') " : End If
                End If
                SQL1 = "SELECT  " & 登入權限1 & " FROM 使用者權限管理表 
                        WHERE  (級別 LIKE '05' OR 級別 LIKE '06' OR 級別 LIKE '07' OR 級別 LIKE '08' OR 級別 LIKE '09') " & SQL2 & " ORDER BY 部門, 職稱, 課別, 組別"
            Else
                SQL1 = "SELECT    " & 登入權限1 & " FROM 使用者權限管理表 
                        WHERE   ((姓名 LIKE N'%" & PA & "%') OR (帳號 LIKE N'%" & PA & "%') OR (密碼 LIKE N'%" & PA & "%') OR (職稱 LIKE N'%" & PA & "%') AND
                                 (級別 LIKE '05' OR 級別 LIKE '06' OR 級別 LIKE '07' OR 級別 LIKE '08' OR 級別 LIKE '09')) " & SQL2 & "
                        ORDER BY  部門, 職稱, 課別, 組別, 姓名"
            End If
            CmdSet_For_DGV()
        End If
    End Sub
    Friend Sub SQL_系統使用者密碼顯示()
        ConnOpen() : SQL1 = "SELECT 密碼 FROM 使用者權限管理表 WHERE 姓名 LIKE N'" & PA39 & "' AND 帳號 LIKE N'" & PA38 & "'" : CmdSet_For_dr()
    End Sub
    Friend Sub SQL_系統使用者ID卡號()
        ConnOpen() : SQL1 = "SELECT  ID卡號  FROM  使用者權限管理表  WHERE  (帳號 LIKE '" & PA41 & "')" : CmdSet_For_dr()
    End Sub
    Friend Sub SQL_系統使用者新增()
        ConnOpen()
        SQL1 = "INSERT INTO 使用者權限管理表 (" & 登入權限1 & ") 
                VALUES (N'" & 系統使用者管理.姓名_tb.Text & "', N'" & 系統使用者管理.帳號_tb.Text & "', N'" & 系統使用者管理.密碼_tb.Text & "', N'" & 系統使用者管理.部門_cb.Text & "',
                        N'" & 系統使用者管理.處別_cb.Text & "', N'" & 系統使用者管理.課別_cb.Text & "', N'" & 系統使用者管理.組別_cb.Text & "', N'" & 系統使用者管理.職稱_cb.Text & "', 
                        N'" & DTP & "', '', N'" & 系統使用者管理.NAS帳號_tb.Text & "', N'" & 系統使用者管理.NAS密碼_tb.Text & "', 
               '" & 系統使用者管理.CheckBox1.Checked & "', '" & 系統使用者管理.CheckBox2.Checked & "', '" & 系統使用者管理.CheckBox3.Checked & "', '" & 系統使用者管理.CheckBox4.Checked &
           "', '" & 系統使用者管理.CheckBox5.Checked & "', '" & 系統使用者管理.CheckBox6.Checked & "', '" & 系統使用者管理.CheckBox7.Checked & "', '" & 系統使用者管理.CheckBox8.Checked &
           "', '" & 系統使用者管理.CheckBox9.Checked & "', '" & 系統使用者管理.CheckBox10.Checked & "', '" & 系統使用者管理.CheckBox11.Checked & "', '" & 系統使用者管理.CheckBox12.Checked &
          "', '" & 系統使用者管理.CheckBox13.Checked & "', '" & 系統使用者管理.CheckBox14.Checked & "', '" & 系統使用者管理.CheckBox15.Checked & "', '" & 系統使用者管理.CheckBox16.Checked &
          "', '" & 系統使用者管理.CheckBox17.Checked & "', '" & 系統使用者管理.CheckBox18.Checked & "', '" & 系統使用者管理.CheckBox19.Checked & "', '" & 系統使用者管理.CheckBox20.Checked &
          "', '" & 系統使用者管理.CheckBox21.Checked & "', '" & 系統使用者管理.CheckBox22.Checked & "', '" & 系統使用者管理.CheckBox23.Checked & "', '" & 系統使用者管理.CheckBox24.Checked &
          "', '" & 系統使用者管理.CheckBox25.Checked & "', '" & 系統使用者管理.CheckBox26.Checked & "', '" & 系統使用者管理.CheckBox27.Checked & "', '" & 系統使用者管理.CheckBox28.Checked &
          "', '" & 系統使用者管理.CheckBox29.Checked & "', '" & 系統使用者管理.CheckBox30.Checked & "', '" & 系統使用者管理.CheckBox31.Checked & "', '" & 系統使用者管理.CheckBox32.Checked &
          "', '" & 系統使用者管理.CheckBox33.Checked & "', '" & 系統使用者管理.CheckBox34.Checked & "', '" & 系統使用者管理.CheckBox35.Checked & "', '" & 系統使用者管理.CheckBox36.Checked &
          "', '" & 系統使用者管理.CheckBox37.Checked & "', '" & 系統使用者管理.CheckBox38.Checked & "', '" & 系統使用者管理.CheckBox39.Checked & "', '" & 系統使用者管理.CheckBox40.Checked &
          "', '" & 系統使用者管理.CheckBox41.Checked & "', '" & 系統使用者管理.CheckBox42.Checked & "', '" & 系統使用者管理.CheckBox43.Checked & "', '" & 系統使用者管理.CheckBox44.Checked &
          "', '" & 系統使用者管理.CheckBox45.Checked & "', '" & 系統使用者管理.CheckBox46.Checked & "', '" & 系統使用者管理.CheckBox47.Checked & "', '" & 系統使用者管理.CheckBox48.Checked &
          "', '" & 系統使用者管理.CheckBox49.Checked & "', '" & 系統使用者管理.CheckBox50.Checked & "', '" & 系統使用者管理.CheckBox51.Checked & "', '" & 系統使用者管理.CheckBox52.Checked &
          "', '" & 系統使用者管理.CheckBox53.Checked & "', '" & 系統使用者管理.CheckBox54.Checked & "', '" & 系統使用者管理.CheckBox55.Checked & "', '" & 系統使用者管理.CheckBox56.Checked &
          "', '" & 系統使用者管理.CheckBox57.Checked & "', '" & 系統使用者管理.CheckBox58.Checked & "', '" & 系統使用者管理.CheckBox59.Checked & "', '" & 系統使用者管理.CheckBox60.Checked &
          "', '" & 系統使用者管理.CheckBox61.Checked & "', '" & 系統使用者管理.CheckBox62.Checked & "', '" & 系統使用者管理.CheckBox63.Checked & "', '" & 系統使用者管理.CheckBox64.Checked &
          "', '" & 系統使用者管理.CheckBox65.Checked & "', '" & 系統使用者管理.CheckBox66.Checked & "', '" & 系統使用者管理.CheckBox67.Checked & "', '" & 系統使用者管理.CheckBox68.Checked &
          "', '" & 系統使用者管理.CheckBox69.Checked & "', '" & 系統使用者管理.CheckBox70.Checked & "', '" & 系統使用者管理.CheckBox71.Checked & "', '" & 系統使用者管理.CheckBox72.Checked &
          "', '" & 系統使用者管理.CheckBox73.Checked & "', '" & 系統使用者管理.CheckBox74.Checked & "', '" & 系統使用者管理.CheckBox75.Checked & "', '" & 系統使用者管理.CheckBox76.Checked &
          "', '" & 系統使用者管理.CheckBox77.Checked & "', '" & 系統使用者管理.CheckBox78.Checked & "', '" & 系統使用者管理.CheckBox79.Checked & "', '" & 系統使用者管理.CheckBox80.Checked &
          "', '" & 系統使用者管理.CheckBox81.Checked & "', '" & 系統使用者管理.CheckBox82.Checked & "', '" & 系統使用者管理.CheckBox83.Checked & "', '" & 系統使用者管理.CheckBox84.Checked &
          "', '" & 系統使用者管理.CheckBox85.Checked & "', '" & 系統使用者管理.CheckBox86.Checked & "', '" & 系統使用者管理.CheckBox87.Checked & "', '" & 系統使用者管理.CheckBox88.Checked &
          "', '" & 系統使用者管理.CheckBox89.Checked & "', '" & 系統使用者管理.CheckBox90.Checked & "', '" & 系統使用者管理.CheckBox91.Checked & "', '" & 系統使用者管理.CheckBox92.Checked &
          "', '" & 系統使用者管理.CheckBox93.Checked & "', '" & 系統使用者管理.CheckBox94.Checked & "', '" & 系統使用者管理.CheckBox95.Checked & "', '" & 系統使用者管理.CheckBox96.Checked &
          "', '" & 系統使用者管理.CheckBox97.Checked & "', '" & 系統使用者管理.CheckBox98.Checked & "', '" & 系統使用者管理.CheckBox99.Checked & "', '" & 系統使用者管理.CheckBox100.Checked &
          "', '" & 系統使用者管理.CheckBox101.Checked & "', '" & 系統使用者管理.CheckBox102.Checked & "', '" & 系統使用者管理.CheckBox103.Checked & "', '" & 系統使用者管理.CheckBox104.Checked &
          "', '" & 系統使用者管理.CheckBox105.Checked & "', '" & 系統使用者管理.CheckBox106.Checked & "', '" & 系統使用者管理.CheckBox107.Checked & "', '" & 系統使用者管理.CheckBox108.Checked &
          "', '" & 系統使用者管理.CheckBox109.Checked & "', '" & 系統使用者管理.CheckBox110.Checked & "', '" & 系統使用者管理.CheckBox111.Checked & "', '" & 系統使用者管理.CheckBox112.Checked &
          "', '" & 系統使用者管理.CheckBox113.Checked & "', '" & 系統使用者管理.CheckBox114.Checked & "', '" & 系統使用者管理.CheckBox115.Checked & "', '" & 系統使用者管理.CheckBox116.Checked &
          "', '" & 系統使用者管理.CheckBox117.Checked & "', '" & 系統使用者管理.CheckBox118.Checked & "', '" & 系統使用者管理.CheckBox119.Checked & "', '" & 系統使用者管理.CheckBox120.Checked &
          "', '" & 系統使用者管理.CheckBox121.Checked & "', '" & 系統使用者管理.CheckBox122.Checked & "', '" & 系統使用者管理.CheckBox123.Checked & "', '" & 系統使用者管理.CheckBox124.Checked &
          "', '" & 系統使用者管理.CheckBox125.Checked & "', '" & 系統使用者管理.CheckBox126.Checked & "', '" & 系統使用者管理.CheckBox127.Checked & "', '" & 系統使用者管理.CheckBox128.Checked & "')"
        CmdSet_For_dr()
    End Sub
    Friend Sub SQL_系統使用者修改()
        ConnOpen()
        SQL1 = "UPDATE 使用者權限管理表 SET 姓名 = N'" & 系統使用者管理.姓名_tb.Text & "'" & PA9 & ", 部門 = N'" & 系統使用者管理.部門_cb.Text & "', 
                                            處別 = N'" & 系統使用者管理.處別_cb.Text & "', 課別 = N'" & 系統使用者管理.課別_cb.Text & "', 
                                            組別 = N'" & 系統使用者管理.組別_cb.Text & "', 職稱 = N'" & 系統使用者管理.職稱_cb.Text & "', 
                                            級別 = N'" & 系統使用者管理.級別_cb.Text & "', NAS帳號 = N'" & 系統使用者管理.NAS帳號_tb.Text & "', 
                                            NAS密碼 = N'" & 系統使用者管理.NAS密碼_tb.Text &
               "', CC01 = '" & 系統使用者管理.CheckBox1.Checked & "', CC02 = '" & 系統使用者管理.CheckBox2.Checked & "', CC03 = '" & 系統使用者管理.CheckBox3.Checked &
               "', CC04 = '" & 系統使用者管理.CheckBox4.Checked & "', CC05 = '" & 系統使用者管理.CheckBox5.Checked & "', CC06 = '" & 系統使用者管理.CheckBox6.Checked &
               "', CC07 = '" & 系統使用者管理.CheckBox7.Checked & "', CC08 = '" & 系統使用者管理.CheckBox8.Checked & "', CC09 = '" & 系統使用者管理.CheckBox9.Checked &
               "', CC10 = '" & 系統使用者管理.CheckBox10.Checked & "', CC11 = '" & 系統使用者管理.CheckBox11.Checked & "', CC12 = '" & 系統使用者管理.CheckBox12.Checked &
               "', CC13 = '" & 系統使用者管理.CheckBox13.Checked & "', CC14 = '" & 系統使用者管理.CheckBox14.Checked & "', CC15 = '" & 系統使用者管理.CheckBox15.Checked &
               "', CC16 = '" & 系統使用者管理.CheckBox16.Checked & "', CC17 = '" & 系統使用者管理.CheckBox17.Checked & "', CC18 = '" & 系統使用者管理.CheckBox18.Checked &
               "', CC19 = '" & 系統使用者管理.CheckBox19.Checked & "', CC20 = '" & 系統使用者管理.CheckBox20.Checked & "', CC21 = '" & 系統使用者管理.CheckBox21.Checked &
               "', CC22 = '" & 系統使用者管理.CheckBox22.Checked & "', CC23 = '" & 系統使用者管理.CheckBox23.Checked & "', CC24 = '" & 系統使用者管理.CheckBox24.Checked &
               "', CC25 = '" & 系統使用者管理.CheckBox25.Checked & "', CC26 = '" & 系統使用者管理.CheckBox26.Checked & "', CC27 = '" & 系統使用者管理.CheckBox27.Checked &
               "', CC28 = '" & 系統使用者管理.CheckBox28.Checked & "', CC29 = '" & 系統使用者管理.CheckBox29.Checked & "', CC30 = '" & 系統使用者管理.CheckBox30.Checked &
               "', CC31 = '" & 系統使用者管理.CheckBox31.Checked & "', CC32 = '" & 系統使用者管理.CheckBox32.Checked & "', CC33 = '" & 系統使用者管理.CheckBox33.Checked &
               "', CC34 = '" & 系統使用者管理.CheckBox34.Checked & "', CC35 = '" & 系統使用者管理.CheckBox35.Checked & "', CC36 = '" & 系統使用者管理.CheckBox36.Checked &
               "', CC37 = '" & 系統使用者管理.CheckBox37.Checked & "', CC38 = '" & 系統使用者管理.CheckBox38.Checked & "', CC39 = '" & 系統使用者管理.CheckBox39.Checked &
               "', CC40 = '" & 系統使用者管理.CheckBox40.Checked & "', CC41 = '" & 系統使用者管理.CheckBox41.Checked & "', CC42 = '" & 系統使用者管理.CheckBox42.Checked &
               "', CC43 = '" & 系統使用者管理.CheckBox43.Checked & "', CC44 = '" & 系統使用者管理.CheckBox44.Checked & "', CC45 = '" & 系統使用者管理.CheckBox45.Checked &
               "', CC46 = '" & 系統使用者管理.CheckBox46.Checked & "', CC47 = '" & 系統使用者管理.CheckBox47.Checked & "', CC48 = '" & 系統使用者管理.CheckBox48.Checked &
               "', CC49 = '" & 系統使用者管理.CheckBox49.Checked & "', CC50 = '" & 系統使用者管理.CheckBox50.Checked & "', CC51 = '" & 系統使用者管理.CheckBox51.Checked &
               "', CC52 = '" & 系統使用者管理.CheckBox52.Checked & "', CC53 = '" & 系統使用者管理.CheckBox53.Checked & "', CC54 = '" & 系統使用者管理.CheckBox54.Checked &
               "', CC55 = '" & 系統使用者管理.CheckBox55.Checked & "', CC56 = '" & 系統使用者管理.CheckBox56.Checked & "', CC57 = '" & 系統使用者管理.CheckBox57.Checked &
               "', CC58 = '" & 系統使用者管理.CheckBox58.Checked & "', CC59 = '" & 系統使用者管理.CheckBox59.Checked & "', CC60 = '" & 系統使用者管理.CheckBox60.Checked &
               "', CC61 = '" & 系統使用者管理.CheckBox61.Checked & "', CC62 = '" & 系統使用者管理.CheckBox62.Checked & "', CC63 = '" & 系統使用者管理.CheckBox63.Checked &
               "', CC64 = '" & 系統使用者管理.CheckBox64.Checked & "', CC65 = '" & 系統使用者管理.CheckBox65.Checked & "', CC66 = '" & 系統使用者管理.CheckBox66.Checked &
               "', CC67 = '" & 系統使用者管理.CheckBox67.Checked & "', CC68 = '" & 系統使用者管理.CheckBox68.Checked & "', CC69 = '" & 系統使用者管理.CheckBox69.Checked &
               "', CC70 = '" & 系統使用者管理.CheckBox70.Checked & "', CC71 = '" & 系統使用者管理.CheckBox71.Checked & "', CC72 = '" & 系統使用者管理.CheckBox72.Checked &
               "', CC73 = '" & 系統使用者管理.CheckBox73.Checked & "', CC74 = '" & 系統使用者管理.CheckBox74.Checked & "', CC75 = '" & 系統使用者管理.CheckBox75.Checked &
               "', CC76 = '" & 系統使用者管理.CheckBox76.Checked & "', CC77 = '" & 系統使用者管理.CheckBox77.Checked & "', CC78 = '" & 系統使用者管理.CheckBox78.Checked &
               "', CC79 = '" & 系統使用者管理.CheckBox79.Checked & "', CC80 = '" & 系統使用者管理.CheckBox80.Checked & "', CC81 = '" & 系統使用者管理.CheckBox81.Checked &
               "', CC82 = '" & 系統使用者管理.CheckBox82.Checked & "', CC83 = '" & 系統使用者管理.CheckBox83.Checked & "', CC84 = '" & 系統使用者管理.CheckBox84.Checked &
               "', CC85 = '" & 系統使用者管理.CheckBox85.Checked & "', CC86 = '" & 系統使用者管理.CheckBox86.Checked & "', CC87 = '" & 系統使用者管理.CheckBox87.Checked &
               "', CC88 = '" & 系統使用者管理.CheckBox88.Checked & "', CC89 = '" & 系統使用者管理.CheckBox89.Checked & "', CC90 = '" & 系統使用者管理.CheckBox90.Checked &
               "', CC91 = '" & 系統使用者管理.CheckBox91.Checked & "', CC92 = '" & 系統使用者管理.CheckBox92.Checked & "', CC93 = '" & 系統使用者管理.CheckBox93.Checked &
               "', CC94 = '" & 系統使用者管理.CheckBox94.Checked & "', CC95 = '" & 系統使用者管理.CheckBox95.Checked & "', CC96 = '" & 系統使用者管理.CheckBox96.Checked &
               "', CC97 = '" & 系統使用者管理.CheckBox97.Checked & "', CC98 = '" & 系統使用者管理.CheckBox98.Checked & "', CC99 = '" & 系統使用者管理.CheckBox99.Checked &
               "', CC100 = '" & 系統使用者管理.CheckBox100.Checked & "', CC101 = '" & 系統使用者管理.CheckBox101.Checked & "', CC102 = '" & 系統使用者管理.CheckBox102.Checked &
               "', CC103 = '" & 系統使用者管理.CheckBox103.Checked & "', CC104 = '" & 系統使用者管理.CheckBox104.Checked & "', CC105 = '" & 系統使用者管理.CheckBox105.Checked &
               "', CC106 = '" & 系統使用者管理.CheckBox106.Checked & "', CC107 = '" & 系統使用者管理.CheckBox107.Checked & "', CC108 = '" & 系統使用者管理.CheckBox108.Checked &
               "', CC109 = '" & 系統使用者管理.CheckBox109.Checked & "', CC110 = '" & 系統使用者管理.CheckBox110.Checked & "', CC111 = '" & 系統使用者管理.CheckBox111.Checked &
               "', CC112 = '" & 系統使用者管理.CheckBox112.Checked & "', CC113 = '" & 系統使用者管理.CheckBox113.Checked & "', CC114 = '" & 系統使用者管理.CheckBox114.Checked &
               "', CC115 = '" & 系統使用者管理.CheckBox115.Checked & "', CC116 = '" & 系統使用者管理.CheckBox116.Checked & "', CC117 = '" & 系統使用者管理.CheckBox117.Checked &
               "', CC118 = '" & 系統使用者管理.CheckBox118.Checked & "', CC119 = '" & 系統使用者管理.CheckBox119.Checked & "', CC120 = '" & 系統使用者管理.CheckBox120.Checked &
               "', CC121 = '" & 系統使用者管理.CheckBox121.Checked & "', CC122 = '" & 系統使用者管理.CheckBox122.Checked & "', CC123 = '" & 系統使用者管理.CheckBox123.Checked &
               "', CC124 = '" & 系統使用者管理.CheckBox124.Checked & "', CC125 = '" & 系統使用者管理.CheckBox125.Checked & "', CC126 = '" & 系統使用者管理.CheckBox126.Checked &
               "', CC127 = '" & 系統使用者管理.CheckBox127.Checked & "', CC128 = '" & 系統使用者管理.CheckBox128.Checked & "'
               WHERE (帳號 = '" & 系統使用者管理.帳號_tb.Text & "')"
        CmdSet_For_dr()
    End Sub
    Friend Sub SQL_系統使用者刪除()
        ConnOpen() : SQL1 = "DELETE FROM 使用者權限管理表 WHERE (帳號 = '" & PA37 & "')" : CmdSet_For_dr()
    End Sub
    Friend Sub SQL_系統使用者管理_下拉清單_部門()
        ConnOpen() : SQL1 = "SELECT 部門 FROM HX部門清單 ORDER BY 部門" : CmdSet_For_dr()
    End Sub
    Friend Sub SQL_系統使用者管理_下拉清單_職稱()
        ConnOpen() : SQL1 = "SELECT 職稱, 級別 FROM HX職稱清單 WHERE (部 LIKE N'%" & PA47 & "%') AND (處 LIKE N'%" & PA48 & "%') ORDER BY 職稱" : CmdSet_For_dr()
    End Sub
    Friend Sub SQL_系統使用者管理_下拉清單_處別()
        ConnOpen() : SQL1 = "SELECT 處 FROM HX處級清單 WHERE 處 LIKE N'" & PA20 & "%' OR 處 LIKE N'0%' ORDER BY 處" : CmdSet_For_dr()
    End Sub
    Friend Sub SQL_系統使用者管理_下拉清單_課別()
        ConnOpen() : SQL1 = "SELECT 課別 FROM HX課別清單 WHERE 課別 LIKE N'" & PA20 & "%' OR 課別 LIKE N'0%' ORDER BY 課別" : CmdSet_For_dr()
    End Sub
    Friend Sub SQL_系統使用者管理_下拉清單_組別()
        ConnOpen() : SQL1 = "SELECT 組別 FROM HX組別清單 WHERE 組別 LIKE N'" & PA20 & "%' OR 組別 LIKE N'0%' ORDER BY 組別" : CmdSet_For_dr()
    End Sub
    Friend Sub SQL_系統使用者管理_組織帶入()
        ConnOpen() : SQL1 = "SELECT 部, 處, 課, 組 FROM HX職稱清單 WHERE 職稱 LIKE N'" & PA & "'" : CmdSet_For_dr()
    End Sub
    Friend Sub SQL_系統認證版本號查詢()
        ConnOpen() : SQL1 = "SELECT 系統認證版本號, 小更新1, 小更新2, 小更新3, 小更新4, 小更新5, 中更新1, 中更新2, 中更新3, 中更新4, 中更新5 FROM 版本號管理 " : CmdSet_For_dr()
    End Sub
    Friend Sub SQL_職稱清單()
        ConnOpen() : SQL1 = "SELECT 部, 處, 課, 組, 職稱, 級別 FROM HX職稱清單 ORDER BY 部,職稱" : CmdSet_For_DGV()
    End Sub
    Friend Sub SQL_部門清單()
        ConnOpen() : SQL1 = "SELECT 部門 FROM HX部門清單 ORDER BY 部門" : CmdSet_For_DGV()
    End Sub
    Friend Sub SQL_處別清單()
        ConnOpen() : SQL1 = "SELECT 處 AS 處別 FROM HX處級清單 WHERE 處 LIKE N'" & PA20 & "%' OR 處 LIKE N'0%' ORDER BY 處" : CmdSet_For_DGV()
    End Sub
    Friend Sub SQL_課別清單()
        ConnOpen() : SQL1 = "SELECT 課別 FROM HX課別清單 WHERE 課別 LIKE N'" & PA20 & "%' OR 課別 LIKE N'0%' ORDER BY 課別" : CmdSet_For_DGV()
    End Sub
    Friend Sub SQL_組別清單()
        ConnOpen() : SQL1 = "SELECT 組別 FROM HX組別清單 WHERE 組別 LIKE N'" & PA20 & "%' OR 組別 LIKE N'0%' ORDER BY 組別" : CmdSet_For_DGV()
    End Sub
    Friend Sub SQL_職稱重複查詢()
        SQL1 = "SELECT 職稱 FROM HX職稱清單 WHERE 職稱 LIKE N'" & 系統組織架構設定.職稱_tb.Text & "'"
    End Sub
    Friend Sub SQL_部門重複查詢()
        SQL1 = "SELECT 部門 FROM HX部門清單 WHERE 部門 LIKE N'" & PA1 & "'"
    End Sub
    Friend Sub SQL_課別重複查詢()
        SQL1 = "SELECT 課別 FROM HX課別清單 WHERE 課別 LIKE N'" & PA1 & "'"
    End Sub
    Friend Sub SQL_組別重複查詢()
        SQL1 = "SELECT 組別 FROM HX組別清單 WHERE 組別 LIKE N'" & PA1 & "'"
    End Sub
    Friend Sub SQL_處級重複查詢()
        SQL1 = "SELECT 處 FROM HX處級清單 WHERE 處 LIKE N'" & PA1 & "'"
    End Sub
    Friend Sub SQL_公司職稱清單_新增()
        SQL1 = "INSERT INTO HX職稱清單 (職稱, 級別) VALUES (N'" & 系統組織架構設定.職稱_tb.Text & "', N'" & 系統組織架構設定.級別_cb.Text & "')"
    End Sub
    Friend Sub SQL_公司部門清單_新增()
        SQL1 = "INSERT INTO HX部門清單 (部門) VALUES (N'" & PA1 & "')"
    End Sub
    Friend Sub SQL_公司課別清單_新增()
        SQL1 = "INSERT INTO HX課別清單 (課別) VALUES (N'" & PA1 & "')"
    End Sub
    Friend Sub SQL_公司組別清單_新增()
        SQL1 = "INSERT INTO HX組別清單 (組別) VALUES (N'" & PA1 & "')"
    End Sub
    Friend Sub SQL_公司處級清單_新增()
        SQL1 = "INSERT INTO HX處級清單 (處) VALUES (N'" & PA1 & "')"
    End Sub
    Friend Sub SQL_公司職稱清單_修改()
        SQL1 = "UPDATE HX職稱清單 SET 職稱 = N'" & PA & "', 級別 = N'" & 系統組織架構設定.級別_cb.Text & "' WHERE 職稱 LIKE N'" & 系統組織架構設定.職稱_tb.Text & "'"
    End Sub
    Friend Sub SQL_系統權限預設表_修改()
        SQL1 = "UPDATE 系統權限預設表 SET 職稱 = N'" & PA & "' WHERE 職稱 LIKE N'" & 系統組織架構設定.職稱_tb.Text & "'"
    End Sub
    Friend Sub SQL_系統跨部門權限表_修改()
        SQL1 = "UPDATE 系統跨部門權限表 SET 職稱 = N'" & PA & "' WHERE 職稱 LIKE N'" & 系統組織架構設定.職稱_tb.Text & "'"
    End Sub
    Friend Sub SQL_使用者權限管理表_修改()
        SQL1 = "UPDATE 使用者權限管理表 SET 職稱 = N'" & PA & "', 級別 = N'" & 系統組織架構設定.級別_cb.Text & "' WHERE 職稱 LIKE N'" & 系統組織架構設定.職稱_tb.Text & "'"
    End Sub
    Friend Sub SQL_公司職稱清單_修改級別()
        SQL1 = "UPDATE HX職稱清單 SET 級別 = N'" & 系統組織架構設定.級別_cb.Text & "' WHERE 職稱 LIKE N'" & 系統組織架構設定.職稱_tb.Text & "'"
    End Sub
    Friend Sub SQL_使用者權限管理表_修改級別()
        SQL1 = "UPDATE 使用者權限管理表 SET 級別 = N'" & 系統組織架構設定.級別_cb.Text & "' WHERE 職稱 LIKE N'" & 系統組織架構設定.職稱_tb.Text & "'"
    End Sub
    Friend Sub SQL_公司職稱清單_刪除()
        ConnOpen() : SQL1 = "DELETE FROM HX職稱清單 WHERE (職稱 = N'" & 系統組織架構設定.職稱_tb.Text & "')" : CmdSet_For_dr()
    End Sub
    Friend Sub SQL_系統權限預設表_刪除()
        ConnOpen() : SQL1 = "DELETE FROM 系統權限預設表 WHERE (職稱 = N'" & 系統組織架構設定.職稱_tb.Text & "')" : CmdSet_For_dr()
    End Sub
    Friend Sub SQL_使用者權限管理表_刪除()
        ConnOpen() : SQL1 = "DELETE FROM 系統跨部門權限表 WHERE (職稱 = N'" & 系統組織架構設定.職稱_tb.Text & "')" : CmdSet_For_dr()
    End Sub
    Friend Sub SQL_公司部門清單_刪除()
        SQL1 = "DELETE FROM HX部門清單 WHERE (部門 = N'" & PA1 & "')"
    End Sub
    Friend Sub SQL_公司課別清單_刪除()
        SQL1 = "DELETE FROM HX課別清單 WHERE (課別 = N'" & PA1 & "')"
    End Sub
    Friend Sub SQL_公司組別清單_刪除()
        SQL1 = "DELETE FROM HX組別清單 WHERE (組別 = N'" & PA1 & "')"
    End Sub
    Friend Sub SQL_公司處級清單_刪除()
        SQL1 = "DELETE FROM HX處級清單 WHERE (處 = N'" & PA1 & "')"
    End Sub
    Friend Sub SQL_公司職稱清單_存檔()
        ConnOpen()
        SQL1 = "UPDATE HX職稱清單 SET 部 = N'" & PA1 & "', 處 = N'" & PA2 & "', 課 = N'" & PA3 & "', 組 = N'" & PA4 & "', 級別 = N'" & PA6 & "'
                   WHERE (職稱 LIKE N'" & PA5 & "')"
        CmdSet_For_dr()
    End Sub
    Friend Sub SQL_公司部門清單_修改部門()
        SQL1 = "UPDATE HX部門清單 SET 部門 = N'" & PA & "' WHERE 部門 LIKE N'" & PA1 & "'"
    End Sub
    Friend Sub SQL_公司職稱清單_修改部門()
        SQL1 = "UPDATE HX職稱清單 SET 部 = N'" & PA & "' WHERE 部 LIKE N'" & PA1 & "'"
    End Sub
    Friend Sub SQL_使用者權限管理表_修改部門()
        SQL1 = "UPDATE 使用者權限管理表 SET 部門 = N'" & PA & "' WHERE 部門 LIKE N'" & PA1 & "'"
    End Sub
    Friend Sub SQL_公司課別清單_修改課別()
        SQL1 = "UPDATE HX課別清單 SET 課別 = N'" & PA & "' WHERE 課別 LIKE N'" & PA1 & "'"
    End Sub
    Friend Sub SQL_公司職稱清單_修改課別()
        SQL1 = "UPDATE HX職稱清單 SET 課 = N'" & PA & "' WHERE 課 LIKE N'" & PA1 & "'"
    End Sub
    Friend Sub SQL_使用者權限管理表_修改課別()
        SQL1 = "UPDATE 使用者權限管理表 SET 課別 = N'" & PA & "' WHERE 課別 LIKE N'" & PA1 & "'"
    End Sub
    Friend Sub SQL_公司組別清單_修改組別()
        SQL1 = "UPDATE HX組別清單 SET 組別 = N'" & PA & "' WHERE 組別 LIKE N'" & PA1 & "'"
    End Sub
    Friend Sub SQL_公司職稱清單_修改組別()
        SQL1 = "UPDATE HX職稱清單 SET 組 = N'" & PA & "' WHERE 組 LIKE N'" & PA1 & "'"
    End Sub
    Friend Sub SQL_使用者權限管理表_修改組別()
        SQL1 = "UPDATE 使用者權限管理表 SET 組別 = N'" & PA & "' WHERE 組別 LIKE N'" & PA1 & "'"
    End Sub
    Friend Sub SQL_公司處級清單_修改處級()
        SQL1 = "UPDATE HX處級清單 SET 處 = N'" & PA & "' WHERE 處 LIKE N'" & PA1 & "'"
    End Sub
    Friend Sub SQL_公司職稱清單_修改處級()
        SQL1 = "UPDATE HX職稱清單 SET 處 = N'" & PA & "' WHERE 處 LIKE N'" & PA1 & "'"
    End Sub
    Friend Sub SQL_使用者權限管理表_修改處級()
        SQL1 = "UPDATE 使用者權限管理表 SET 處別 = N'" & PA & "' WHERE 處別 LIKE N'" & PA1 & "'"
    End Sub
    Friend Sub SQL_系統權限預設表_新增()
        SQL1 = "INSERT INTO 系統權限預設表 (職稱, " & 系統權限 & ") VALUES (N'" & 系統組織架構設定.職稱_tb.Text & "', 
                                    N'0', N'0', N'0', N'0', N'0', N'0', N'0', N'0', N'0', N'0', N'0', N'0', N'0', N'0', N'0', N'0', N'0', N'0', N'0', N'0', N'0', N'0', N'0', N'0', N'0', N'0', 
                                    N'0', N'0', N'0', N'0', N'0', N'0', N'0', N'0', N'0', N'0', N'0', N'0', N'0', N'0', N'0', N'0', N'0', N'0', N'0', N'0', N'0', N'0', N'0', N'0', N'0', N'0', 
                                    N'0', N'0', N'0', N'0', N'0', N'0', N'0', N'0', N'0', N'0', N'0', N'0', N'0', N'0', N'0', N'0', N'0', N'0', N'0', N'0', N'0', N'0', N'0', N'0', N'0', N'0', 
                                    N'0', N'0', N'0', N'0', N'0', N'0', N'0', N'0', N'0', N'0', N'0', N'0', N'0', N'0', N'0', N'0', N'0', N'0', N'0', N'0', N'0', N'0', N'0', N'0', N'0', N'0', 
                                    N'0', N'0', N'0', N'0', N'0', N'0', N'0', N'0', N'0', N'0', N'0', N'0', N'0', N'0', N'0', N'0', N'0', N'0', N'0', N'0', N'0', N'0', N'0', N'0')"
        '                     1     2     3     4     5     6     7     8     9    10    11    12    13    14    15    16    17    18    19    20    21    22    23    24    25    26
        '                  26*4+24 = 1228
    End Sub
    Friend Sub SQL_系統權限預設表()
        ConnOpen()
        SQL1 = "SELECT 系統權限預設表.職稱, HX職稱清單.級別, " & 系統權限 & " FROM 系統權限預設表 INNER JOIN HX職稱清單 ON 系統權限預設表.職稱 = HX職稱清單.職稱
                ORDER BY 系統權限預設表.職稱"
        CmdSet_For_DGV()
    End Sub
    Friend Sub SQL_系統權限預設表修改()
        ConnOpen()
        SQL1 = "UPDATE " & PA & " SET  CC01 = '" & 系統權限預設表.CheckBox1.Checked & "', CC02 = '" & 系統權限預設表.CheckBox2.Checked & "', CC03 = '" & 系統權限預設表.CheckBox3.Checked &
               "', CC04 = '" & 系統權限預設表.CheckBox4.Checked & "', CC05 = '" & 系統權限預設表.CheckBox5.Checked & "', CC06 = '" & 系統權限預設表.CheckBox6.Checked &
               "', CC07 = '" & 系統權限預設表.CheckBox7.Checked & "', CC08 = '" & 系統權限預設表.CheckBox8.Checked & "', CC09 = '" & 系統權限預設表.CheckBox9.Checked &
               "', CC10 = '" & 系統權限預設表.CheckBox10.Checked & "', CC11 = '" & 系統權限預設表.CheckBox11.Checked & "', CC12 = '" & 系統權限預設表.CheckBox12.Checked &
               "', CC13 = '" & 系統權限預設表.CheckBox13.Checked & "', CC14 = '" & 系統權限預設表.CheckBox14.Checked & "', CC15 = '" & 系統權限預設表.CheckBox15.Checked &
               "', CC16 = '" & 系統權限預設表.CheckBox16.Checked & "', CC17 = '" & 系統權限預設表.CheckBox17.Checked & "', CC18 = '" & 系統權限預設表.CheckBox18.Checked &
               "', CC19 = '" & 系統權限預設表.CheckBox19.Checked & "', CC20 = '" & 系統權限預設表.CheckBox20.Checked & "', CC21 = '" & 系統權限預設表.CheckBox21.Checked &
               "', CC22 = '" & 系統權限預設表.CheckBox22.Checked & "', CC23 = '" & 系統權限預設表.CheckBox23.Checked & "', CC24 = '" & 系統權限預設表.CheckBox24.Checked &
               "', CC25 = '" & 系統權限預設表.CheckBox25.Checked & "', CC26 = '" & 系統權限預設表.CheckBox26.Checked & "', CC27 = '" & 系統權限預設表.CheckBox27.Checked &
               "', CC28 = '" & 系統權限預設表.CheckBox28.Checked & "', CC29 = '" & 系統權限預設表.CheckBox29.Checked & "', CC30 = '" & 系統權限預設表.CheckBox30.Checked &
               "', CC31 = '" & 系統權限預設表.CheckBox31.Checked & "', CC32 = '" & 系統權限預設表.CheckBox32.Checked & "', CC33 = '" & 系統權限預設表.CheckBox33.Checked &
               "', CC34 = '" & 系統權限預設表.CheckBox34.Checked & "', CC35 = '" & 系統權限預設表.CheckBox35.Checked & "', CC36 = '" & 系統權限預設表.CheckBox36.Checked &
               "', CC37 = '" & 系統權限預設表.CheckBox37.Checked & "', CC38 = '" & 系統權限預設表.CheckBox38.Checked & "', CC39 = '" & 系統權限預設表.CheckBox39.Checked &
               "', CC40 = '" & 系統權限預設表.CheckBox40.Checked & "', CC41 = '" & 系統權限預設表.CheckBox41.Checked & "', CC42 = '" & 系統權限預設表.CheckBox42.Checked &
               "', CC43 = '" & 系統權限預設表.CheckBox43.Checked & "', CC44 = '" & 系統權限預設表.CheckBox44.Checked & "', CC45 = '" & 系統權限預設表.CheckBox45.Checked &
               "', CC46 = '" & 系統權限預設表.CheckBox46.Checked & "', CC47 = '" & 系統權限預設表.CheckBox47.Checked & "', CC48 = '" & 系統權限預設表.CheckBox48.Checked &
               "', CC49 = '" & 系統權限預設表.CheckBox49.Checked & "', CC50 = '" & 系統權限預設表.CheckBox50.Checked & "', CC51 = '" & 系統權限預設表.CheckBox51.Checked &
               "', CC52 = '" & 系統權限預設表.CheckBox52.Checked & "', CC53 = '" & 系統權限預設表.CheckBox53.Checked & "', CC54 = '" & 系統權限預設表.CheckBox54.Checked &
               "', CC55 = '" & 系統權限預設表.CheckBox55.Checked & "', CC56 = '" & 系統權限預設表.CheckBox56.Checked & "', CC57 = '" & 系統權限預設表.CheckBox57.Checked &
               "', CC58 = '" & 系統權限預設表.CheckBox58.Checked & "', CC59 = '" & 系統權限預設表.CheckBox59.Checked & "', CC60 = '" & 系統權限預設表.CheckBox60.Checked &
               "', CC61 = '" & 系統權限預設表.CheckBox61.Checked & "', CC62 = '" & 系統權限預設表.CheckBox62.Checked & "', 
                   CC64 = '" & 系統權限預設表.CheckBox64.Checked & "', CC65 = '" & 系統權限預設表.CheckBox65.Checked & "', CC66 = '" & 系統權限預設表.CheckBox66.Checked &
               "', CC67 = '" & 系統權限預設表.CheckBox67.Checked & "', CC68 = '" & 系統權限預設表.CheckBox68.Checked & "', CC69 = '" & 系統權限預設表.CheckBox69.Checked &
               "', CC70 = '" & 系統權限預設表.CheckBox70.Checked & "', CC71 = '" & 系統權限預設表.CheckBox71.Checked & "', CC72 = '" & 系統權限預設表.CheckBox72.Checked &
               "', CC73 = '" & 系統權限預設表.CheckBox73.Checked & "', CC74 = '" & 系統權限預設表.CheckBox74.Checked & "', CC75 = '" & 系統權限預設表.CheckBox75.Checked &
               "', CC76 = '" & 系統權限預設表.CheckBox76.Checked & "', CC77 = '" & 系統權限預設表.CheckBox77.Checked & "', CC78 = '" & 系統權限預設表.CheckBox78.Checked &
               "', CC79 = '" & 系統權限預設表.CheckBox79.Checked & "', CC80 = '" & 系統權限預設表.CheckBox80.Checked & "', CC81 = '" & 系統權限預設表.CheckBox81.Checked &
               "', CC82 = '" & 系統權限預設表.CheckBox82.Checked & "', CC83 = '" & 系統權限預設表.CheckBox83.Checked & "', CC84 = '" & 系統權限預設表.CheckBox84.Checked &
               "', CC85 = '" & 系統權限預設表.CheckBox85.Checked & "', CC86 = '" & 系統權限預設表.CheckBox86.Checked & "', CC87 = '" & 系統權限預設表.CheckBox87.Checked &
               "', CC88 = '" & 系統權限預設表.CheckBox88.Checked & "', CC89 = '" & 系統權限預設表.CheckBox89.Checked & "', CC90 = '" & 系統權限預設表.CheckBox90.Checked &
               "', CC91 = '" & 系統權限預設表.CheckBox91.Checked & "', CC92 = '" & 系統權限預設表.CheckBox92.Checked & "', CC93 = '" & 系統權限預設表.CheckBox93.Checked &
               "', CC94 = '" & 系統權限預設表.CheckBox94.Checked & "', CC95 = '" & 系統權限預設表.CheckBox95.Checked & "', CC96 = '" & 系統權限預設表.CheckBox96.Checked &
               "', CC97 = '" & 系統權限預設表.CheckBox97.Checked & "', CC98 = '" & 系統權限預設表.CheckBox98.Checked & "', CC99 = '" & 系統權限預設表.CheckBox99.Checked &
               "', CC100 = '" & 系統權限預設表.CheckBox100.Checked & "', CC101 = '" & 系統權限預設表.CheckBox101.Checked & "', CC102 = '" & 系統權限預設表.CheckBox102.Checked &
               "', CC103 = '" & 系統權限預設表.CheckBox103.Checked & "', CC104 = '" & 系統權限預設表.CheckBox104.Checked & "', CC105 = '" & 系統權限預設表.CheckBox105.Checked &
               "', CC106 = '" & 系統權限預設表.CheckBox106.Checked & "', CC107 = '" & 系統權限預設表.CheckBox107.Checked & "', CC108 = '" & 系統權限預設表.CheckBox108.Checked &
               "', CC109 = '" & 系統權限預設表.CheckBox109.Checked & "', CC110 = '" & 系統權限預設表.CheckBox110.Checked & "', CC111 = '" & 系統權限預設表.CheckBox111.Checked &
               "', CC112 = '" & 系統權限預設表.CheckBox112.Checked & "', CC113 = '" & 系統權限預設表.CheckBox113.Checked & "', CC114 = '" & 系統權限預設表.CheckBox114.Checked &
               "', CC115 = '" & 系統權限預設表.CheckBox115.Checked & "', CC116 = '" & 系統權限預設表.CheckBox116.Checked & "', CC117 = '" & 系統權限預設表.CheckBox117.Checked &
               "', CC118 = '" & 系統權限預設表.CheckBox118.Checked & "', CC119 = '" & 系統權限預設表.CheckBox119.Checked & "', CC120 = '" & 系統權限預設表.CheckBox120.Checked &
               "', CC121 = '" & 系統權限預設表.CheckBox121.Checked & "', CC122 = '" & 系統權限預設表.CheckBox122.Checked & "', CC123 = '" & 系統權限預設表.CheckBox123.Checked &
               "', CC124 = '" & 系統權限預設表.CheckBox124.Checked & "', CC125 = '" & 系統權限預設表.CheckBox125.Checked & "', CC126 = '" & 系統權限預設表.CheckBox126.Checked &
               "', CC127 = '" & 系統權限預設表.CheckBox127.Checked & "', CC128 = '" & 系統權限預設表.CheckBox128.Checked & "'
               WHERE (職稱 = '" & PA10 & "')"
        CmdSet_For_dr()
    End Sub
    Friend Sub SQL_跨部門主管權限設定_清單()
        ConnOpen()
        SQL1 = "SELECT 姓名, 職稱, 級別, 部門, 處別, 課別, 組別, 帳號 FROM 使用者權限管理表 
                WHERE CC88 = 1 AND CC63 = 0
                ORDER BY 部門, 職稱, 課別, 組別"
        CmdSet_For_DGV()
    End Sub
    Friend Sub SQL_跨部門主管權限設定_確認有無資料()
        ConnOpen()
        SQL1 = "SELECT 姓名 FROM 系統跨部門權限表 WHERE (姓名 = N'" & PA1 & "' AND 帳號 = N'" & PA2 & "')"
        CmdSet_For_dr()
    End Sub
    Friend Sub SQL_跨部門主管權限設定_未設定過()
        If PA3 = "00" Then
            SQL2 = " "
        ElseIf PA3 = "01" Then
            SQL2 = "WHERE     (HX職稱清單.級別 NOT LIKE N'00') "
        ElseIf PA3 = "02" Then
            SQL2 = "WHERE     (HX職稱清單.級別 NOT LIKE N'01') AND (HX職稱清單.級別 NOT LIKE N'00') "
        ElseIf PA3 = "03" Then
            SQL2 = "WHERE     (HX職稱清單.級別 NOT LIKE N'02') AND (HX職稱清單.級別 NOT LIKE N'01') AND (HX職稱清單.級別 NOT LIKE N'00') "
        ElseIf PA3 = "04" Then
            SQL2 = "WHERE     (HX職稱清單.級別 NOT LIKE N'03') AND (HX職稱清單.級別 NOT LIKE N'02') AND (HX職稱清單.級別 NOT LIKE N'01') AND (HX職稱清單.級別 NOT LIKE N'00') "
        ElseIf PA3 = "05" Then
            SQL2 = "WHERE     (HX職稱清單.級別 NOT LIKE N'04') AND (HX職稱清單.級別 NOT LIKE N'03') AND (HX職稱清單.級別 NOT LIKE N'02') AND (HX職稱清單.級別 NOT LIKE N'01') AND 
                              (HX職稱清單.級別 NOT LIKE N'00') "
        ElseIf PA3 = "06" Then
            SQL2 = "WHERE     (HX職稱清單.級別 NOT LIKE N'05') AND (HX職稱清單.級別 NOT LIKE N'04') AND (HX職稱清單.級別 NOT LIKE N'03') AND (HX職稱清單.級別 NOT LIKE N'02') AND 
                              (HX職稱清單.級別 NOT LIKE N'01') AND (HX職稱清單.級別 NOT LIKE N'00') "
        ElseIf PA3 = "07" Then
            SQL2 = "WHERE     (HX職稱清單.級別 NOT LIKE N'06') AND (HX職稱清單.級別 NOT LIKE N'05') AND (HX職稱清單.級別 NOT LIKE N'04') AND (HX職稱清單.級別 NOT LIKE N'03') AND 
                              (HX職稱清單.級別 NOT LIKE N'02') AND (HX職稱清單.級別 NOT LIKE N'01') AND (HX職稱清單.級別 NOT LIKE N'00') "
        ElseIf PA3 = "08" Then
            SQL2 = "WHERE     (HX職稱清單.級別 NOT LIKE N'07') AND (HX職稱清單.級別 NOT LIKE N'06') AND (HX職稱清單.級別 NOT LIKE N'05') AND (HX職稱清單.級別 NOT LIKE N'04') AND 
                              (HX職稱清單.級別 NOT LIKE N'03') AND (HX職稱清單.級別 NOT LIKE N'02') AND (HX職稱清單.級別 NOT LIKE N'01') AND (HX職稱清單.級別 NOT LIKE N'00') "
        ElseIf PA3 = "09" Then
            SQL2 = "WHERE     (HX職稱清單.級別 NOT LIKE N'08') AND (HX職稱清單.級別 NOT LIKE N'07') AND (HX職稱清單.級別 NOT LIKE N'06') AND (HX職稱清單.級別 NOT LIKE N'05') AND 
                              (HX職稱清單.級別 NOT LIKE N'04') AND (HX職稱清單.級別 NOT LIKE N'03') AND (HX職稱清單.級別 NOT LIKE N'02') AND (HX職稱清單.級別 NOT LIKE N'01') AND 
                              (HX職稱清單.級別 NOT LIKE N'00') "
        End If
        ConnOpen()
        SQL1 = "SELECT     HX職稱清單.部, HX職稱清單.處, HX職稱清單.課, HX職稱清單.組, HX職稱清單.職稱, 
                           系統跨部門權限表_暫存檔.時效, 系統跨部門權限表_暫存檔.授權, HX職稱清單.級別
                FROM       HX職稱清單 LEFT OUTER JOIN 系統跨部門權限表_暫存檔 ON HX職稱清單.職稱 = 系統跨部門權限表_暫存檔.職稱 " & SQL2 & "
                ORDER BY   HX職稱清單.部, HX職稱清單.職稱"
        CmdSet_For_DGV()
    End Sub
    Friend Sub SQL_跨部門主管權限設定_已設定過()
        If PA3 = "00" Then
            SQL2 = "WHERE     (系統跨部門權限表.姓名 LIKE N'" & PA1 & "') AND (系統跨部門權限表.帳號 LIKE N'" & PA2 & "') "
        ElseIf PA3 = "01" Then
            SQL2 = "WHERE     (HX職稱清單.級別 NOT LIKE N'00') AND (系統跨部門權限表.姓名 LIKE N'" & PA1 & "') AND (系統跨部門權限表.帳號 LIKE N'" & PA2 & "') "
        ElseIf PA3 = "02" Then
            SQL2 = "WHERE     (HX職稱清單.級別 NOT LIKE N'01') AND (HX職稱清單.級別 NOT LIKE N'00') AND (系統跨部門權限表.姓名 LIKE N'" & PA1 & "') AND (系統跨部門權限表.帳號 LIKE N'" & PA2 & "') "
        ElseIf PA3 = "03" Then
            SQL2 = "WHERE     (HX職稱清單.級別 NOT LIKE N'02') AND (HX職稱清單.級別 NOT LIKE N'01') AND (HX職稱清單.級別 NOT LIKE N'00') AND (系統跨部門權限表.姓名 LIKE N'" & PA1 & "') AND 
                              (系統跨部門權限表.帳號 LIKE N'" & PA2 & "') "
        ElseIf PA3 = "04" Then
            SQL2 = "WHERE     (HX職稱清單.級別 NOT LIKE N'03') AND (HX職稱清單.級別 NOT LIKE N'02') AND (HX職稱清單.級別 NOT LIKE N'01') AND (HX職稱清單.級別 NOT LIKE N'00') AND 
                              (系統跨部門權限表.姓名 LIKE N'" & PA1 & "') AND (系統跨部門權限表.帳號 LIKE N'" & PA2 & "') "
        ElseIf PA3 = "05" Then
            SQL2 = "WHERE     (HX職稱清單.級別 NOT LIKE N'04') AND (HX職稱清單.級別 NOT LIKE N'03') AND (HX職稱清單.級別 NOT LIKE N'02') AND (HX職稱清單.級別 NOT LIKE N'01') AND 
                              (HX職稱清單.級別 NOT LIKE N'00') AND (系統跨部門權限表.姓名 LIKE N'" & PA1 & "') AND (系統跨部門權限表.帳號 LIKE N'" & PA2 & "') "
        ElseIf PA3 = "06" Then
            SQL2 = "WHERE     (HX職稱清單.級別 NOT LIKE N'05') AND (HX職稱清單.級別 NOT LIKE N'04') AND (HX職稱清單.級別 NOT LIKE N'03') AND (HX職稱清單.級別 NOT LIKE N'02') AND 
                              (HX職稱清單.級別 NOT LIKE N'01') AND (HX職稱清單.級別 NOT LIKE N'00') AND (系統跨部門權限表.姓名 LIKE N'" & PA1 & "') AND 
                              (系統跨部門權限表.帳號 LIKE N'" & PA2 & "') "
        ElseIf PA3 = "07" Then
            SQL2 = "WHERE     (HX職稱清單.級別 NOT LIKE N'06') AND (HX職稱清單.級別 NOT LIKE N'05') AND (HX職稱清單.級別 NOT LIKE N'04') AND (HX職稱清單.級別 NOT LIKE N'03') AND 
                              (HX職稱清單.級別 NOT LIKE N'02') AND (HX職稱清單.級別 NOT LIKE N'01') AND (HX職稱清單.級別 NOT LIKE N'00') AND (系統跨部門權限表.姓名 LIKE N'" & PA1 & "') AND 
                              (系統跨部門權限表.帳號 LIKE N'" & PA2 & "') "
        ElseIf PA3 = "08" Then
            SQL2 = "WHERE     (HX職稱清單.級別 NOT LIKE N'07') AND (HX職稱清單.級別 NOT LIKE N'06') AND (HX職稱清單.級別 NOT LIKE N'05') AND (HX職稱清單.級別 NOT LIKE N'04') AND 
                              (HX職稱清單.級別 NOT LIKE N'03') AND (HX職稱清單.級別 NOT LIKE N'02') AND (HX職稱清單.級別 NOT LIKE N'01') AND (HX職稱清單.級別 NOT LIKE N'00') AND 
                              (系統跨部門權限表.姓名 LIKE N'" & PA1 & "') AND (系統跨部門權限表.帳號 LIKE N'" & PA2 & "') "
        ElseIf PA3 = "08" Then
            SQL2 = "WHERE     (HX職稱清單.級別 NOT LIKE N'08') AND (HX職稱清單.級別 NOT LIKE N'07') AND (HX職稱清單.級別 NOT LIKE N'06') AND (HX職稱清單.級別 NOT LIKE N'05') AND 
                              (HX職稱清單.級別 NOT LIKE N'04') AND (HX職稱清單.級別 NOT LIKE N'03') AND (HX職稱清單.級別 NOT LIKE N'02') AND (HX職稱清單.級別 NOT LIKE N'01') AND 
                              (HX職稱清單.級別 NOT LIKE N'00') AND (系統跨部門權限表.姓名 LIKE N'" & PA1 & "') AND (系統跨部門權限表.帳號 LIKE N'" & PA2 & "') "
        End If
        ConnOpen()
        SQL1 = "SELECT     HX職稱清單.部, HX職稱清單.處, HX職稱清單.課, HX職稱清單.組, 
                           HX職稱清單.職稱, 
                           系統跨部門權限表.時效, 系統跨部門權限表.授權, HX職稱清單.級別
                FROM       HX職稱清單 LEFT OUTER JOIN 系統跨部門權限表 ON HX職稱清單.職稱 = 系統跨部門權限表.職稱 " & SQL2 & "
                ORDER BY   HX職稱清單.部, HX職稱清單.職稱"
        CmdSet_For_DGV()
    End Sub
    Friend Sub SQL_跨部門主管權限設定_存檔前確認()
        ConnOpen()
        SQL1 = "SELECT 職稱 FROM 系統跨部門權限表 WHERE (職稱 = N'" & PA4 & "' AND 姓名 = N'" & PA1 & "' AND 帳號 = N'" & PA2 & "')"
        CmdSet_For_dr()
    End Sub
    Friend Sub SQL_跨部門主管權限設定_修改()
        ConnOpen()
        SQL1 = "UPDATE 系統跨部門權限表 SET 時效 = N'" & PA5 & "', 授權 = N'" & BL1 & "' WHERE (職稱 = N'" & PA4 & "' AND 姓名 = N'" & PA1 & "' AND 帳號 = N'" & PA2 & "')"
        CmdSet_For_dr()
    End Sub
    Friend Sub SQL_跨部門主管權限設定_新增()
        ConnOpen()
        SQL1 = "INSERT INTO 系統跨部門權限表 (姓名, 帳號, 職稱, 時效, 授權) VALUES (N'" & PA1 & "',N'" & PA2 & "',N'" & PA4 & "',N'" & PA5 & "',N'" & BL1 & "')"
        CmdSet_For_dr()
    End Sub
    Friend Sub SQL_跨部門主管權限設定_刪除()
        ConnOpen() : SQL1 = "DELETE 系統跨部門權限表 WHERE (姓名 = N'" & PA & "')" : CmdSet_For_dr()
    End Sub
    Friend Sub SQL_主資料庫LOG檔案截斷()
        Dim DSF(1) As String : Dim NB1 As Integer = 0
        ConnOpen_圖庫SQL() : SQL1 = "USE [" & PA & "]" : CmdSet_For_dr()
        ConnOpen_圖庫SQL() : SQL1 = "select name from sys.database_files;" : CmdSet_For_dr()
        While (dr.Read()) : DSF(NB1) = dr("name").ToString : NB1 += 1 : End While

        If PA = DSF(0) Then : Else
            ConnOpen_圖庫SQL() : SQL1 = "alter database [" & PA & "] modify file(name=[" & DSF(0) & "], newname =[" & PA & "])" : CmdSet_For_dr()
        End If

        If PA & "_log" = DSF(1) Then : Else
            ConnOpen_圖庫SQL() : SQL1 = "alter database [" & PA & "] modify file(name=[" & DSF(1) & "], newname=[" & PA & "_log])" : CmdSet_For_dr()
        End If

        ConnOpen_圖庫SQL() : SQL1 = "ALTER DATABASE [" & PA & "]
                                   SET RECOVERY SIMPLE;" : CmdSet_For_dr()
        ConnOpen_圖庫SQL() : SQL1 = "DBCC SHRINKFILE ([" & PA & "_Log], 1);" : CmdSet_For_dr()
        ConnOpen_圖庫SQL() : SQL1 = "ALTER DATABASE [" & PA & "]
                                   SET RECOVERY FULL;" : CmdSet_For_dr()
    End Sub
    Friend Sub SQL_伺服器1清單()
        ConnOpen()
        SQL1 = "SELECT   DB_NAME(database_id) AS 資料庫 FROM sys.master_files 
                WHERE   (DB_NAME(database_id) LIKE 'FH%')  GROUP BY DB_NAME(database_id) ORDER BY DB_NAME(database_id)"
        CmdSet_For_DGV()
    End Sub
    Friend Sub SQL_資料庫狀態()
        ConnOpen()
        SQL1 = "SELECT  DB_NAME(database_id) AS [資料庫名稱], physical_name AS [磁碟路徑], type_desc AS [類型描述], 
                        state_desc  AS [狀態描述], size * 8.0 / 1024  AS [使用容量]
                FROM    sys.master_files
                WHERE  (DB_NAME(database_id) LIKE N'FH%')"
        CmdSet_For_DGV()
    End Sub
    Friend Sub SQL_系統閒置時間設定修改()
        ConnOpen()
        SQL1 = "UPDATE 系統閒置時間設定 SET timeExit = N'" & 系統通用變數管理.時間1_tb.Text & "', timeExit2 = N'" & 系統通用變數管理.時間2_tb.Text & "' 
                WHERE (timeExit = N'" & PA1 & "' AND timeExit2 = N'" & PA2 & "')"
        CmdSet_For_dr()
    End Sub
    Friend Sub SQL_圖片資料庫管理查詢()
        ConnOpen() : SQL1 = "SELECT 圖片資料庫, 是否可用 FROM 圖片資料庫管理 ORDER BY 圖片資料庫" : CmdSet_For_DGV()
    End Sub
    Friend Sub SQL_文件資料庫管理查詢()
        ConnOpen() : SQL1 = "SELECT 文件資料庫, 是否可用 FROM 文件資料庫管理 ORDER BY 文件資料庫" : CmdSet_For_DGV()
    End Sub
    Friend Sub SQL_系統閒置時間設定讀取()
        ConnOpen() : SQL1 = "SELECT timeExit, timeExit2 FROM 系統閒置時間設定" : CmdSet_For_dr()
    End Sub
    Friend Sub SQL_系統預測值修改()
        ConnOpen()
        SQL1 = "UPDATE 系統預設值 SET 密碼重設天數 = N'" & 系統通用變數管理.密碼重設天數_tb.Text & "', 行政採購二級 = N'" & 系統通用變數管理.行政簽核_tb.Text & "' , 
                       建築採購二級 = N'" & 系統通用變數管理.建築簽核_tb.Text & "',比例1 = N'" & 系統通用變數管理.NUP_3.Text & "',比例2 = N'" & 系統通用變數管理.NUP_4.Text & "',
                       比例3 = N'" & 系統通用變數管理.NUP_5.Text & "', 圖片伺服器上限 = '" & 系統通用變數管理.MAX_nud.Value & "'"
        CmdSet_For_dr()
    End Sub
    Friend Sub SQL_圖片資料庫管理查詢1()
        ConnOpen() : SQL1 = "SELECT 圖片資料庫, 是否可用 FROM 圖片資料庫管理 WHERE 圖片資料庫 LIKE N'" & 系統通用變數管理.圖片資料庫名稱_tb.Text & "'" : CmdSet_For_dr()
    End Sub
    Friend Sub SQL_文件資料庫管理查詢1()
        ConnOpen() : SQL1 = "SELECT 文件資料庫, 是否可用 FROM 文件資料庫管理 WHERE 文件資料庫 LIKE N'" & 系統通用變數管理.文件資料庫名稱_tb.Text & "'" : CmdSet_For_dr()
    End Sub
    Friend Sub SQL_圖片資料庫管理查詢新增()
        ConnOpen()
        SQL1 = "INSERT INTO 圖片資料庫管理 (圖片資料庫, 是否可用) VALUES ('" & 系統通用變數管理.圖片資料庫名稱_tb.Text & "','" & 系統通用變數管理.是否可用_ch.Checked & "')"
        CmdSet_For_dr()
    End Sub
    Friend Sub SQL_文件資料庫管理查詢新增()
        ConnOpen()
        SQL1 = "INSERT INTO 文件資料庫管理 (文件資料庫, 是否可用) VALUES ('" & 系統通用變數管理.文件資料庫名稱_tb.Text & "','" & 系統通用變數管理.是否可用1_ch.Checked & "')"
        CmdSet_For_dr()
    End Sub
    Friend Sub SQL_圖片資料庫管理查詢修改()
        ConnOpen()
        SQL1 = "UPDATE 圖片資料庫管理 SET 是否可用 = '" & 系統通用變數管理.是否可用_ch.Checked & "' WHERE 圖片資料庫 LIKE N'" & 系統通用變數管理.圖片資料庫名稱_tb.Text & "'"
        CmdSet_For_dr()
    End Sub
    Friend Sub SQL_文件資料庫管理查詢修改()
        ConnOpen()
        SQL1 = "UPDATE 文件資料庫管理 SET 是否可用 = '" & 系統通用變數管理.是否可用1_ch.Checked & "' WHERE 文件資料庫 LIKE N'" & 系統通用變數管理.文件資料庫名稱_tb.Text & "'"
        CmdSet_For_dr()
    End Sub
    Friend Sub SQL_資料庫選擇()
        ConnOpen() : SQL1 = "SELECT  TOP (1) 文件資料庫  FROM  文件資料庫管理  WHERE  (是否可用 = 0)  ORDER BY  文件資料庫" : CmdSet_For_dr()
    End Sub
    '---------------------簽名檔管理-----------------------------------------------------------------------------------------------------------------
    Friend Sub SQL_簽名檔清單()
        ConnOpen() : SQL1 = "SELECT 圖片流水號, 簽名檔人名 FROM HX主管簽名檔管理 ORDER BY 圖片流水號" : CmdSet_For_DGV()
    End Sub
    Friend Sub SQL_姓名清單()
        ConnOpen() : SQL1 = "SELECT 姓名 FROM 使用者權限管理表 WHERE (CC63 = 0)  ORDER BY 職稱" : CmdSet_For_dr()
    End Sub
    Friend Sub SQL_簽名檔圖片讀取()
        ConnOpen() : SQL1 = "SELECT 簽名檔圖片 FROM HX主管簽名檔管理 WHERE 圖片流水號 LIKE N'" & PA20 & "'" : CmdSet_For_dr()
    End Sub
    Friend Sub SQL_簽名檔新增()
        ConnOpen() : SQL1 = "INSERT INTO HX主管簽名檔管理 (圖片流水號, 簽名檔人名, 簽名檔圖片) SELECT '" & PA20 & "', '" & PA21 & "', @binary_file" : CmdSet_For_dr_pic()
    End Sub
    Friend Sub SQL_簽名檔最末編號讀取()
        ConnOpen() : SQL1 = "SELECT TOP (1) 圖片流水號 FROM HX主管簽名檔管理 ORDER BY 圖片流水號 DESC" : CmdSet_For_dr()
    End Sub
    Friend Sub SQL_簽名檔刪除()
        ConnOpen() : SQL1 = "DELETE FROM HX主管簽名檔管理 WHERE (圖片流水號 = N'" & PA20 & "')" : CmdSet_For_dr()
    End Sub
End Module